<template>
  <q-card color="white" class="no-shadow no-border-radius" text-color="gray">
    <q-card-section>
      <div class="text-h5 text-secondary text-bold" v-if="!this.isEdit">
       Create a new User
      </div>
      <div class="text-h5 text-secondary text-bold" v-else>
        Update user
      </div>
    </q-card-section>
    <q-card-section>
      <q-input
        v-model="postForm.user_id"
        label="User ID"
        readonly
        type="number"
        bottom-slots
        outlined
        square
        dense
      >
        <template v-slot:prepend>
          <q-icon name="sort_by_alpha"/>
        </template>
      </q-input>
      <q-input
        v-model="postForm.full_name"
        label="Full Name"
        bottom-slots
        :error="('full_name' in errors)"
        :error-message="('full_name' in errors) ? errors.full_name[0] : ''"
        outlined
        square
        dense
      >
        <template v-slot:prepend>
          <q-icon name="sort_by_alpha"/>
        </template>
      </q-input>
      <q-input
        v-model="postForm.username"
        label="User Name"
        bottom-slots
        outlined
        :error="('username' in errors)"
        :error-message="('username' in errors) ? errors.username[0] : ''"
        square
        dense
      >
        <template v-slot:prepend>
          <q-icon name="sort_by_alpha"/>
        </template>
      </q-input>
      <q-input
        v-model="postForm.email"
        label="Email"
        bottom-slots
        :error="('email' in errors)"
        :error-message="('email' in errors) ? errors.email[0] : ''"
        outlined
        square
        dense
      >
        <template v-slot:prepend>
          <q-icon name="sort_by_alpha"/>
        </template>
      </q-input>
    </q-card-section>
    <q-card-actions>
      <q-btn :loading="loadingUpdate" v-if="isEdit" label="Update" @click="updateForm" color="secondary" />
      <q-btn v-else :loading="loadingCreate" label="Create" @click="createForm" color="positive" />
      <q-btn label="Cancel" @click="closeDialog" color="negative" />
    </q-card-actions>
  </q-card>
</template>

<script>
export default {
  // name: 'ComponentName',
  props: {
    isEdit: {
      type: Boolean,
      default: false
    },
    id: {
      type: Number,
      default: null
    },
  },
  data () {
    return {
      postForm: {
        user_id: null,
        username:null,
        full_name:null,
        email:null,
      },
      loadingCreate: false,
      loadingUpdate: false,
      errors: {},
    }
  },
  methods:{
    closeDialog(){
      this.$emit('userCanceled', true)
    },
    updateForm(){
      this.loadingUpdate=true
      this.$store.dispatch('users/updateUser',{data:this.postForm,id:this.id}).then(()=>{
        this.loadingUpdate=false
        this.$emit('userUpdated', true)
      }).catch((error)=>{
        this.loadingUpdate=false
      })
    },
    createForm(){
      this.loadingCreate=true
      this.$store.dispatch('users/createUser',this.postForm).then(()=>{
        this.loadingCreate=false
        this.$emit('userCreated', true)
      }).catch(()=>{
        this.loadingCreate=false
      })
    }
  },
  created(){
    if (this.isEdit) {
      this.$q.loading.show()
      this.$store.dispatch('users/getUser',this.id).then((res)=>{
        this.postForm={
          user_id: res.user_id,
          username:res.username,
          full_name:res.full_name,
          email:res.email,
        }
        this.$q.loading.hide()
      }).catch((err)=>{
        this.$q.loading.hide()
      })
    }
  },
  watch: {
    getErrors(val) {
      this.errors = val
    },
  },
  computed:{
    getErrors: {
      get() {
        return this.$store.state.users.errors.errors
      }
    },
  }
}
</script>
